import { workspace } from '@gant-lowcode/lowcode-engine';
import { Search, Balloon } from '@alifd/next';
import React, { useCallback, useState, useEffect, useRef } from 'react';
import { FileIcon, IconArrowRight } from './icon';
import './index.scss';
import { intl } from '../../locale';
import { AddFile } from '../addFile';
function filterResourceList(resourceList, handler) {
  if (typeof handler === 'function') {
    return handler(resourceList);
  }
  return resourceList;
}
export function ResourcePaneContent(props) {
  var _props$options;
  var _ref = props.pluginContext || {},
    workspace = _ref.workspace;
  var _useState = useState(filterResourceList(workspace === null || workspace === void 0 ? void 0 : workspace.resourceList, props === null || props === void 0 ? void 0 : (_props$options = props.options) === null || _props$options === void 0 ? void 0 : _props$options.filterResourceList)),
    resourceList = _useState[0],
    setResourceList = _useState[1];
  workspace === null || workspace === void 0 ? void 0 : workspace.onResourceListChange(function () {
    var _props$options2;
    setResourceList(filterResourceList(workspace === null || workspace === void 0 ? void 0 : workspace.resourceList, props === null || props === void 0 ? void 0 : (_props$options2 = props.options) === null || _props$options2 === void 0 ? void 0 : _props$options2.filterResourceList));
  });
  return /*#__PURE__*/React.createElement(ResourceListTree, {
    resourceList: resourceList,
    defaultExpandedCategoryKeys: props.defaultExpandedCategoryKeys,
    defaultExpandAll: props.defaultExpandAll,
    pluginContext: props.pluginContext,
    behaviors: props.behaviors,
    options: props.options
  });
}
function ResourceListTree(props) {
  var _props$pluginContext, _props$pluginContext$, _props$pluginContext$2;
  var _useState2 = useState({}),
    category = _useState2[0],
    setCategory = _useState2[1];
  var _useState3 = useState(),
    filterValue = _useState3[0],
    setFilterValue = _useState3[1];
  var _useState4 = useState(((_props$pluginContext = props.pluginContext) === null || _props$pluginContext === void 0 ? void 0 : (_props$pluginContext$ = _props$pluginContext.workspace.window) === null || _props$pluginContext$ === void 0 ? void 0 : (_props$pluginContext$2 = _props$pluginContext$.resource) === null || _props$pluginContext$2 === void 0 ? void 0 : _props$pluginContext$2.id) + ''),
    activeId = _useState4[0],
    setActiveId = _useState4[1];
  useEffect(function () {
    var _props$resourceList;
    var category = {};
    (_props$resourceList = props.resourceList) === null || _props$resourceList === void 0 ? void 0 : _props$resourceList.forEach(function (d) {
      category[d.category] = category[d.category] || [];
      category[d.category].push(d);
    });
    setCategory(category);
  }, [props.resourceList]);
  var handleSearchChange = useCallback(function (key) {
    setFilterValue(key);
  }, []);
  workspace.onChangeActiveWindow(function () {
    var _workspace$window, _workspace$window$res;
    setActiveId(((_workspace$window = workspace.window) === null || _workspace$window === void 0 ? void 0 : (_workspace$window$res = _workspace$window.resource) === null || _workspace$window$res === void 0 ? void 0 : _workspace$window$res.id) + '');
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-filter"
  }, /*#__PURE__*/React.createElement(Search, {
    hasClear: true,
    shape: "simple",
    placeholder: intl('view_manager.components.resourceTree.SearchPagesAndComponents'),
    className: "resource-list-filter-search-input",
    value: filterValue,
    onChange: handleSearchChange
  }), /*#__PURE__*/React.createElement(AddFile, {
    options: props.options,
    pluginContext: props.pluginContext
  })), /*#__PURE__*/React.createElement("div", {
    className: "resource-tree"
  }, Array.from(Object.entries(category)).map(function (_ref2) {
    var categoryName = _ref2[0],
      resourceArr = _ref2[1];
    return /*#__PURE__*/React.createElement(ResourceGroup, {
      defaultExpandAll: props.defaultExpandAll,
      defaultExpandedCategoryKeys: props.defaultExpandedCategoryKeys,
      activeId: activeId,
      categoryName: categoryName,
      resourceArr: resourceArr,
      filterValue: filterValue,
      pluginContext: props.pluginContext,
      behaviors: props.behaviors,
      options: props.options,
      depth: 0
    });
  })));
}
function ResourceGroup(props) {
  var _props$defaultExpande, _props$pluginContext2, _props$pluginContext3, _props$options3, _props$options3$resou;
  var _useState5 = useState(props.defaultExpandAll || ((_props$defaultExpande = props.defaultExpandedCategoryKeys) === null || _props$defaultExpande === void 0 ? void 0 : _props$defaultExpande.includes(props.categoryName))),
    expanded = _useState5[0],
    setExpanded = _useState5[1];
  var resourceArr = props.resourceArr.filter(function (d) {
    return !props.filterValue || [d.options.title, d.options.slug, d.options.componentName].some(function (d) {
      var _props$filterValue;
      return d && d.toLowerCase().includes((_props$filterValue = props.filterValue) === null || _props$filterValue === void 0 ? void 0 : _props$filterValue.toLowerCase());
    });
  });
  if (!resourceArr || !resourceArr.length) {
    return null;
  }
  if (!props.categoryName || props.categoryName === 'undefined') {
    return /*#__PURE__*/React.createElement("div", {
      className: "resource-tree-group",
      "data-depth": props.depth
    }, resourceArr.map(function (d) {
      return /*#__PURE__*/React.createElement(ResourceItem, {
        children: d.children,
        icon: d.icon,
        key: d.title,
        activeId: props.activeId,
        resource: d,
        behaviors: props.behaviors,
        options: props.options,
        pluginContext: props.pluginContext,
        depth: props.depth + 1
      });
    }));
  }
  var ContextMenu = ((_props$pluginContext2 = props.pluginContext) === null || _props$pluginContext2 === void 0 ? void 0 : (_props$pluginContext3 = _props$pluginContext2.commonUI) === null || _props$pluginContext3 === void 0 ? void 0 : _props$pluginContext3.ContextMenu) || React.Fragment;
  var indent = props.depth * 28 + 12;
  var style = {
    paddingLeft: indent,
    marginLeft: -indent
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-group",
    "data-depth": props.depth
  }, /*#__PURE__*/React.createElement(ContextMenu, {
    menus: ((_props$options3 = props.options) === null || _props$options3 === void 0 ? void 0 : (_props$options3$resou = _props$options3.resourceGroupContextMenuActions) === null || _props$options3$resou === void 0 ? void 0 : _props$options3$resou.call(_props$options3, props.pluginContext, resourceArr)) || []
  }, /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-group-wrap",
    style: style,
    onClick: function onClick() {
      setExpanded(!expanded);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-expand " + (expanded ? 'expanded' : '')
  }, /*#__PURE__*/React.createElement(IconArrowRight, null)), /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-group-icon"
  }, /*#__PURE__*/React.createElement(FileIcon, null)), /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-group-title"
  }, props.categoryName))), expanded && /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-children"
  }, resourceArr.map(function (d) {
    return /*#__PURE__*/React.createElement(ResourceItem, {
      children: d.children,
      icon: d.icon,
      key: d.options.id,
      activeId: props.activeId,
      resource: d,
      behaviors: props.behaviors,
      options: props.options,
      pluginContext: props.pluginContext,
      depth: props.depth + 1
    });
  })));
}
function ResourceItem(props) {
  var _display, _props$resource, _props$resource$confi, _props$children, _props$resource2, _props$pluginContext4, _props$pluginContext5, _props$options4, _props$options4$resou, _props$resource3, _props$resource4, _props$resource5, _props$resource6, _props$resource6$opti, _props$resource7, _props$resource8, _props$resource8$opti, _props$resource9, _props$resource9$opti, _props$resource$optio, _props$resource$optio2, _props$resource10, _props$resource10$con, _props$children2;
  var _useState6 = useState(false),
    expanded = _useState6[0],
    setExpanded = _useState6[1];
  var ref = useRef(null);
  var PropsIcon = props.icon;
  var Behaviors = props.behaviors;
  var display = (_display = (_props$resource = props.resource) === null || _props$resource === void 0 ? void 0 : (_props$resource$confi = _props$resource.config) === null || _props$resource$confi === void 0 ? void 0 : _props$resource$confi.display) !== null && _display !== void 0 ? _display : true;
  var indent = props.depth * 28 + 12;
  var style = {
    paddingLeft: indent,
    marginLeft: -indent
  };
  if (!display) {
    return null;
  }
  var children = (_props$children = props.children) === null || _props$children === void 0 ? void 0 : _props$children.filter(function (d) {
    var _d$config;
    return ((_d$config = d.config) === null || _d$config === void 0 ? void 0 : _d$config.display) !== false;
  });
  var _ref3 = ((_props$resource2 = props.resource) === null || _props$resource2 === void 0 ? void 0 : _props$resource2.config) || {},
    disabled = _ref3.disabled,
    tips = _ref3.tips;
  var ContextMenu = ((_props$pluginContext4 = props.pluginContext) === null || _props$pluginContext4 === void 0 ? void 0 : (_props$pluginContext5 = _props$pluginContext4.commonUI) === null || _props$pluginContext5 === void 0 ? void 0 : _props$pluginContext5.ContextMenu) || React.Fragment;
  var context = /*#__PURE__*/React.createElement(ContextMenu, {
    menus: ((_props$options4 = props.options) === null || _props$options4 === void 0 ? void 0 : (_props$options4$resou = _props$options4.resourceContextMenuActions) === null || _props$options4$resou === void 0 ? void 0 : _props$options4$resou.call(_props$options4, props.pluginContext, props.resource)) || []
  }, /*#__PURE__*/React.createElement("div", {
    ref: ref,
    className: "resource-tree-group-node " + (disabled ? 'resource-tree-group-disabled' : '') + " " + (props.activeId === ((_props$resource3 = props.resource) === null || _props$resource3 === void 0 ? void 0 : _props$resource3.options.id) || props.activeId === ((_props$resource4 = props.resource) === null || _props$resource4 === void 0 ? void 0 : _props$resource4.id) ? 'active' : ''),
    "data-depth": props.depth
  }, /*#__PURE__*/React.createElement("div", {
    onClick: function onClick() {
      var _props$pluginContext6;
      if (disabled) {
        return;
      }
      props.resource && ((_props$pluginContext6 = props.pluginContext) === null || _props$pluginContext6 === void 0 ? void 0 : _props$pluginContext6.workspace.openEditorWindow(props.resource));
    },
    className: "resource-tree-title",
    style: style
  }, (_props$resource5 = props.resource) !== null && _props$resource5 !== void 0 && _props$resource5.options.modified ? /*#__PURE__*/React.createElement(Balloon, {
    v2: true,
    trigger: /*#__PURE__*/React.createElement("div", {
      className: "resource-tree-group-item-modified-wrap"
    }, /*#__PURE__*/React.createElement("div", {
      className: "resource-tree-group-item-modified"
    })),
    triggerType: "hover",
    align: "bl",
    title: ""
  }, props.resource.options.modifiedTips) : null, (children && children.length || null) && /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-expand " + (expanded ? 'expanded' : ''),
    onClick: function onClick(e) {
      setExpanded(!expanded);
      e.stopPropagation();
      e.preventDefault();
    }
  }, /*#__PURE__*/React.createElement(IconArrowRight, null)), /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-group-item-icon"
  }, PropsIcon && /*#__PURE__*/React.createElement(PropsIcon, null)), /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-group-title-label"
  }, ((_props$resource6 = props.resource) === null || _props$resource6 === void 0 ? void 0 : (_props$resource6$opti = _props$resource6.options) === null || _props$resource6$opti === void 0 ? void 0 : _props$resource6$opti.label) || ((_props$resource7 = props.resource) === null || _props$resource7 === void 0 ? void 0 : _props$resource7.title), (_props$resource8 = props.resource) !== null && _props$resource8 !== void 0 && (_props$resource8$opti = _props$resource8.options) !== null && _props$resource8$opti !== void 0 && _props$resource8$opti.slug || (_props$resource9 = props.resource) !== null && _props$resource9 !== void 0 && (_props$resource9$opti = _props$resource9.options) !== null && _props$resource9$opti !== void 0 && _props$resource9$opti.componentName ? /*#__PURE__*/React.createElement("span", {
    className: "resource-tree-group-item-code"
  }, "(", ((_props$resource$optio = props.resource.options) === null || _props$resource$optio === void 0 ? void 0 : _props$resource$optio.slug) || ((_props$resource$optio2 = props.resource.options) === null || _props$resource$optio2 === void 0 ? void 0 : _props$resource$optio2.componentName), ")") : null), /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-group-item-behaviors"
  }, Behaviors && ((_props$resource10 = props.resource) === null || _props$resource10 === void 0 ? void 0 : (_props$resource10$con = _props$resource10.config) === null || _props$resource10$con === void 0 ? void 0 : _props$resource10$con.disableBehaviors) !== true ? /*#__PURE__*/React.createElement(Behaviors, {
    resource: props.resource,
    safeNode: ref === null || ref === void 0 ? void 0 : ref.current
  }) : null)), expanded && children !== null && children !== void 0 && children.length ? /*#__PURE__*/React.createElement("div", {
    className: "resource-tree-children"
  }, (_props$children2 = props.children) === null || _props$children2 === void 0 ? void 0 : _props$children2.map(function (child) {
    return /*#__PURE__*/React.createElement(ResourceItem, {
      children: child.children,
      icon: child.icon,
      key: child.id,
      activeId: props.activeId,
      resource: child,
      behaviors: props.behaviors,
      options: props.options,
      pluginContext: props.pluginContext,
      depth: props.depth + 1
    });
  })) : null));
  if (tips) {
    return /*#__PURE__*/React.createElement(Balloon, {
      v2: true,
      trigger: /*#__PURE__*/React.createElement("div", null, context),
      triggerType: "hover",
      align: "r",
      title: ""
    }, tips);
  }
  return context;
}