import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import * as React from 'react';
import Icon from './icon';
import { Pane } from './pane';
import './index.scss';
import { intl } from './locale';
var ViewManagerPane = function ViewManagerPane(ctx, options) {
  if (options === void 0) {
    options = {};
  }
  return {
    // 插件的初始化函数，在引擎初始化之后会立刻调用
    init: function init() {
      return _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var _options$showIconText, _options$skeletonConf;
        var showIconText;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              showIconText = (_options$showIconText = options.showIconText) !== null && _options$showIconText !== void 0 ? _options$showIconText : true; // 往引擎增加面板
              ctx.skeleton.add(_extends({
                area: 'leftArea',
                name: 'ViewManagerPane',
                props: {
                  icon: /*#__PURE__*/React.createElement(Icon, {
                    showIconText: showIconText
                  }),
                  description: intl('view_manager.src.ViewManagement'),
                  className: "workspace-view-pane-icon " + (showIconText ? 'show-icon-text' : null)
                },
                panelProps: {
                  width: '200px'
                },
                content: Pane,
                contentProps: {
                  options: _extends({
                    handleClose: function handleClose() {
                      ctx.skeleton.hidePanel('ViewManagerPane');
                    }
                  }, options),
                  pluginContext: ctx
                }
              }, options.skeletonConfig || {}, {
                type: ((_options$skeletonConf = options.skeletonConfig) === null || _options$skeletonConf === void 0 ? void 0 : _options$skeletonConf.type) || 'PanelDock'
              }));
            case 2:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    }
  };
};

// 插件名，注册环境下唯一
ViewManagerPane.pluginName = 'ViewManagerPane';
ViewManagerPane.meta = {
  // 依赖的插件（插件名数组）
  dependencies: [],
  engines: {
    lowcodeEngine: '^1.3.0' // 插件需要配合 ^1.0.0 的引擎才可运行
  },
  preferenceDeclaration: {
    title: intl('view_manager.src.ViewManagementPanelPlugIn'),
    properties: [{
      key: 'init',
      type: 'function',
      description: ''
    }, {
      key: 'handleClose',
      type: 'function',
      description: ''
    }, {
      key: 'showIconText',
      type: 'boolean',
      description: ''
    }, {
      key: 'skeletonConfig',
      type: 'object',
      description: ''
    }, {
      key: 'contextMenuActions',
      type: 'function',
      description: '右键菜单项'
    }, {
      key: 'resourceContextMenuActions',
      type: 'function',
      description: '右键资源项，菜单项'
    }, {
      key: 'resourceGroupContextMenuActions',
      type: 'function',
      description: '右键资源组，菜单项'
    }, {
      key: 'filterResourceList',
      type: 'function',
      description: ''
    }, {
      key: 'showIconText',
      type: 'boolean',
      description: ''
    }, {
      key: 'skeletonConfig',
      type: 'object',
      description: ''
    }]
  }
};
export default ViewManagerPane;