import * as React from 'react';
import { IPublicModelPluginContext, IPublicModelResource, IPublicTypeSkeletonConfig, IPublicTypeContextMenuAction } from '@gant-lowcode/lowcode-types';
import './index.scss';
export interface IOptions {
    init?: (ctx: IPublicModelPluginContext) => {};
    renderAddFileComponent?: () => React.JSX.Element;
    handleClose?: (force?: boolean) => void;
    filterResourceList?: () => {};
    showIconText?: boolean;
    skeletonConfig?: IPublicTypeSkeletonConfig;
    /**
     * 右键菜单项
     */
    contextMenuActions?: (ctx: IPublicModelPluginContext) => IPublicTypeContextMenuAction[];
    /**
     * 右键资源项，菜单项
     */
    resourceContextMenuActions?: (ctx: IPublicModelPluginContext, resource: IPublicModelResource) => IPublicTypeContextMenuAction[];
    /**
     * 右键资源组，菜单项
     */
    resourceGroupContextMenuActions?: (ctx: IPublicModelPluginContext, resources: IPublicModelResource[]) => IPublicTypeContextMenuAction[];
}
declare const ViewManagerPane: {
    (ctx: IPublicModelPluginContext, options?: IOptions): {
        init(): Promise<void>;
    };
    pluginName: string;
    meta: {
        dependencies: any[];
        engines: {
            lowcodeEngine: string;
        };
        preferenceDeclaration: {
            title: any;
            properties: {
                key: string;
                type: string;
                description: string;
            }[];
        };
    };
};
export default ViewManagerPane;
