"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var React = _interopRequireWildcard(require("react"));
var _icon = _interopRequireDefault(require("./icon"));
var _pane = require("./pane");
require("./index.scss");
var _locale = require("./locale");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var ViewManagerPane = function ViewManagerPane(ctx, options) {
  if (options === void 0) {
    options = {};
  }
  return {
    // 插件的初始化函数，在引擎初始化之后会立刻调用
    init: function init() {
      return (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var _options$showIconText, _options$skeletonConf;
        var showIconText;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              showIconText = (_options$showIconText = options.showIconText) !== null && _options$showIconText !== void 0 ? _options$showIconText : true; // 往引擎增加面板
              ctx.skeleton.add((0, _extends2["default"])({
                area: 'leftArea',
                name: 'ViewManagerPane',
                props: {
                  icon: /*#__PURE__*/React.createElement(_icon["default"], {
                    showIconText: showIconText
                  }),
                  description: (0, _locale.intl)('view_manager.src.ViewManagement'),
                  className: "workspace-view-pane-icon " + (showIconText ? 'show-icon-text' : null)
                },
                panelProps: {
                  width: '200px'
                },
                content: _pane.Pane,
                contentProps: {
                  options: (0, _extends2["default"])({
                    handleClose: function handleClose() {
                      ctx.skeleton.hidePanel('ViewManagerPane');
                    }
                  }, options),
                  pluginContext: ctx
                }
              }, options.skeletonConfig || {}, {
                type: ((_options$skeletonConf = options.skeletonConfig) === null || _options$skeletonConf === void 0 ? void 0 : _options$skeletonConf.type) || 'PanelDock'
              }));
            case 2:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    }
  };
};

// 插件名，注册环境下唯一
ViewManagerPane.pluginName = 'ViewManagerPane';
ViewManagerPane.meta = {
  // 依赖的插件（插件名数组）
  dependencies: [],
  engines: {
    lowcodeEngine: '^1.3.0' // 插件需要配合 ^1.0.0 的引擎才可运行
  },
  preferenceDeclaration: {
    title: (0, _locale.intl)('view_manager.src.ViewManagementPanelPlugIn'),
    properties: [{
      key: 'init',
      type: 'function',
      description: ''
    }, {
      key: 'handleClose',
      type: 'function',
      description: ''
    }, {
      key: 'showIconText',
      type: 'boolean',
      description: ''
    }, {
      key: 'skeletonConfig',
      type: 'object',
      description: ''
    }, {
      key: 'contextMenuActions',
      type: 'function',
      description: '右键菜单项'
    }, {
      key: 'resourceContextMenuActions',
      type: 'function',
      description: '右键资源项，菜单项'
    }, {
      key: 'resourceGroupContextMenuActions',
      type: 'function',
      description: '右键资源组，菜单项'
    }, {
      key: 'filterResourceList',
      type: 'function',
      description: ''
    }, {
      key: 'showIconText',
      type: 'boolean',
      description: ''
    }, {
      key: 'skeletonConfig',
      type: 'object',
      description: ''
    }]
  }
};
var _default = exports["default"] = ViewManagerPane;